//-------------------------------------------------
// little Tippie Basis - Station
//
// erstellt von Michael Walischewski
//          am: 05.02.2011
//
// luft in einer Loop, un wartet auf das Setzen der Flags
// INT_nIRQ
// INT_USART
// Diese werden in den Interrupthandler fr den RFM12 / INT0
// und USART gesetzt.
//
// wurde ein empfangenes Byte im FIFO -> durch setzen der INT_nIRQ
// signalisiert, wird in die Routine Receive das Polling
// der restlichen Bytes durchgefhrt, entweder erfolgreich oder bis zum
// Timeout
//
//



#include <avr/io.h>

#include <util/delay.h>
#include "../Utils/RFM12.h"
#include "../Utils/ETH200.h"
#include "../Utils/EEPROM.h"
#include <stdlib.h>
#include "../Utils/uart128.h"
#include <avr/interrupt.h>
#include <util/crc16.h>
#include "../Utils/RFMProtokoll.h"
#include "../HomeReceiver/global.h"
#include <inttypes.h>
#include <string.h>

#define Header  0x99
#define Netz    0x01
#define SAdress 0x01
#define ZAdress 0x01
#define Sensor  0x01
#define F_CPU 16000000UL




int main(void)
{


    uint32_t EthAdresse = 0;

    unsigned char i     = 0;



    uint8_t TempH=0;
    uint8_t TempL=0;
    char Buffer[20];



    uint16_t Hight =0;
    uint16_t Lowt = 0;
    uint8_t Status = 0;
    unsigned char eprom;

    unsigned char tmp;



    volatile unsigned char RFM12Message[20];
    volatile unsigned char ACKPacket[7] = { 0xFF, 0xFF, 0x04, 0x01, 0xAA, 0xFF, 0xFF } ;  // Quelle, Ziel, MSGTYP, Bytes, Daten, CRC1,CRC2
    volatile unsigned char UsartPacket[8];                                                // Packet fr den Datenaustausch mit dem PC
    volatile char UsartRxBuffer[20] = {"\0"};                                             // Empfangsspeicher Usart
    char *pch;
    char Node;                                                                       // Pointer fr die USARTRxBuffer Zerlegung

    uint8_t temp=0;
    unsigned short cnt=0;

    INT_nIRQ = 0; // Bool fr NIRQ Verarbeitung
    INT_USART = 0;


    _delay_ms(500); // Bis RFM12 POR durchgefhrt hat !



    portInit();





  //  asm("cli");
    RFM12init();
    sei();
    USART0_Init(57600);
   // USART0_Puts("little Tippie gestartet !");



    ID=1; // Wir sind der Master

    //Sensor ID einlesen
    eprom=EEPROM_read(0);    // nchste freie Sensor ID
    if(eprom==0xff){
       EEPROM_write(0,0x04); // interne Table ! hier ist der Zeiger fr die nchste freie Nummer die der Sensor erhlt nach der Anmeldung !
    }

    // prfen ob nchste freie ETH Adresse im EEPROM abgelegt ist.
     EthAdresse = (EthAdresse<<8) | EEPROM_read(8);
     EthAdresse = (EthAdresse<<8) | EEPROM_read(16);
     EthAdresse = (EthAdresse<<8) | EEPROM_read(24);

     //noch keine definiert , dann holen wir das jetzt nach !
     if(EthAdresse==0xFFFFFF){
       EEPROM_write(8,0x00);
       EEPROM_write(16,0x10);
       EEPROM_write(24,0x11);
     }








while(1){

     if(INT_nIRQ !=0 ){

        Status=Receive(RFM12Message); // wieso wird der Global INT_nIRQ nicht in der Funktion Receive gesetzt ? sollte doch gehen ....
        INT_nIRQ=0;

        if(Status==1){
           sendACK(ACKPacket,RFM12Message);
           USART0_Puts("TEMP;");
           USART0_Puts(itoa(RFM12Message[0],Buffer,10));
           USART0_Puts(";");
           TempH = RFM12Message[4];
           TempL = RFM12Message[5];
           temp  = (unsigned int) TempH;
           temp <<= 8;
           temp |= (unsigned int) TempL;
           if(temp>>4 > 85){
             // Minuswert
             Hight = (temp>>4) ^ 0b111111111111;
             USART0_Puts("-");
           }
           else{
             Hight = (temp>>4);
             USART0_Puts("+");
           }
           Lowt  = (temp << 12) / 6553;

           USART0_Puts(itoa(Hight,Buffer,10));
           USART0_Puts(".");
           USART0_Puts(itoa(Lowt,Buffer,10));
           USART0_Puts("#");
        }

           //Baterie Paket
        if(Status==6){
           sendACK(ACKPacket,RFM12Message);

           INT_nIRQ=0;
           USART0_Puts("BATT;");
           USART0_Puts(itoa(RFM12Message[0],Buffer,10));
           USART0_Puts(";");

           USART0_Puts(itoa(RFM12Message[4],Buffer,10));
           USART0_Puts(".");
           USART0_Puts(itoa(RFM12Message[5],Buffer,10));
           USART0_Puts("#");

        }

                // Neue Adresse
        if(Status==2){
           tmp             = EEPROM_read(0);
           USART0_Puts("NEW;");
           USART0_Puts(itoa(tmp,Buffer,10));
           USART0_Puts(";");
           for(i=0;i<8;i++){
               USART0_Puts(itoa(RFM12Message[4+i],Buffer,10));
               USART0_Puts(";");
           }
           USART0_Puts("#");
           sendID(RFM12Message,tmp);
           EEPROM_write(0,++tmp);
         }

         Status=0;
     }// if INT_nIRQ

     // USART Verarbeitung !
     if(INT_USART==1){ // UsartRxBuffer[0] != '\0'){

        USART0_Readline(UsartRxBuffer);
        i=0;
        pch=strtok(UsartRxBuffer,";");
        while(pch != NULL){
           UsartPacket[i++]=atoi(pch);
           pch = strtok(NULL, ";");             // empfangenes Paket von der Perl-Schnittstelle splitten
        }

        UsartRxBuffer[0] = '\0';
        // Jetzt schauen was wir genau machen sollen
        // 1 - Temperatur ndern !
        // 2 - Anlernen

        if(UsartPacket[0] == 1){

            EthAdresse = (EthAdresse<<8) | UsartPacket[1];
            EthAdresse = (EthAdresse<<8) | UsartPacket[2];
            EthAdresse = (EthAdresse<<8) | UsartPacket[3];
            EthSetTemp(UsartPacket[4],EthAdresse);

         }
         if(UsartPacket[0] == 2){
         // nchste freie ETH ADresse einlesen

            Node = UsartPacket[1];

            EthAdresse = (EthAdresse<<8) | EEPROM_read(8);
            EthAdresse = (EthAdresse<<8) | EEPROM_read(16);
            EthAdresse = (EthAdresse<<8) | EEPROM_read(24);

            EthLearn(EthAdresse);

            USART0_Puts("LEARN;");
            USART0_Puts(itoa(UsartPacket[1],Buffer,10));
            USART0_Puts(";");
            USART0_Puts(itoa((uint8_t)(EthAdresse>>16),Buffer,10));
            USART0_Puts(";");
            USART0_Puts(itoa((uint8_t)(EthAdresse>>8),Buffer,10));
            USART0_Puts(";");
            USART0_Puts(itoa((uint8_t)(EthAdresse),Buffer,10));
            USART0_Puts("#");

            EthAdresse++;

            EEPROM_write(8,(uint8_t)(EthAdresse>>16));
            EEPROM_write(16,(uint8_t)(EthAdresse>>8));
            EEPROM_write(24,(uint8_t)(EthAdresse));
         }

         INT_nIRQ=0;
         INT_USART=0;
      }//if (UsartRxBuf...
   }// while(1)
}


